--- This code is automatically generated by the addrgen_wb.py tool
--- Please don't edit it manaully, unless you really have to do it.

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

library general_cores;
use general_cores.wishbone_pkg.all;

library work;
use work.dummy_register_wb_pkg.all;

entity dummy_register_wb is
  port (
    slave_i : in t_wishbone_slave_in;
    slave_o : out t_wishbone_slave_out;

    ctrlreg0_o : out  t_ctrlreg0;
    ctrlreg1_o : out  t_ctrlreg1;
    ctrlreg2_o : out  t_ctrlreg2;
    ctrlreg3_o : out  t_ctrlreg3;
    ctrlreg4_o : out  t_ctrlreg4;
    ctrlreg5_o : out  t_ctrlreg5;
    ctrlreg6_o : out  t_ctrlreg6;

    rst_n_i : in std_logic;
    clk_sys_i : in std_logic
    );

end dummy_register_wb;

architecture gener of dummy_register_wb is
    signal int_ctrlreg0_o : t_ctrlreg0 := std_logic_vector(to_unsigned(0,32)); -- Hex value: 0x0
    signal int_ctrlreg1_o : t_ctrlreg1 := std_logic_vector(to_unsigned(0,32)); -- Hex value: 0x0
    signal int_ctrlreg2_o : t_ctrlreg2 := std_logic_vector(to_unsigned(0,32)); -- Hex value: 0x0
    signal int_ctrlreg3_o : t_ctrlreg3 := std_logic_vector(to_unsigned(0,32)); -- Hex value: 0x0
    signal int_ctrlreg4_o : t_ctrlreg4 := std_logic_vector(to_unsigned(0,32)); -- Hex value: 0x0
    signal int_ctrlreg5_o : t_ctrlreg5 := std_logic_vector(to_unsigned(0,32)); -- Hex value: 0x0
    signal int_ctrlreg6_o : t_ctrlreg6 := std_logic_vector(to_unsigned(0,32)); -- Hex value: 0x0

  -- Internal WB declaration
  signal int_regs_wb_m_o : t_wishbone_master_out;
  signal int_regs_wb_m_i : t_wishbone_master_in;
  signal int_addr : std_logic_vector(4-1 downto 0);
  signal wb_up_o : t_wishbone_slave_out_array(0 to 0);
  signal wb_up_i : t_wishbone_slave_in_array(0 to 0);
  signal wb_m_o : t_wishbone_master_out_array(0 to 1-1);
  signal wb_m_i : t_wishbone_master_in_array(0 to 1-1);

  -- Constants
  constant c_address : t_wishbone_address_array(0 to 1-1) := (0=>"00000000000000000000000000000000");
  constant c_mask : t_wishbone_address_array(0 to 1-1) := (0=>"00000000000000000000000000000000");

begin
  wb_up_i(0) <= slave_i;
  slave_o <= wb_up_o(0);
  int_addr <= int_regs_wb_m_o.adr(4-1 downto 0);

-- Main crossbar 
  xwb_crossbar_1: entity general_cores.xwb_crossbar
  generic map (
     g_num_masters => 1,
     g_num_slaves  => 1,
     g_registered  => false,
     g_address     => c_address,
     g_mask        => c_mask)
  port map (
     clk_sys_i => clk_sys_i,
     rst_n_i   => rst_n_i,
     slave_i   => wb_up_i,
     slave_o   => wb_up_o,
     master_i  => wb_m_i,
     master_o  => wb_m_o,
    sdb_sel_o => open);

-- Process for register access
  process(clk_sys_i)
  begin
    if rising_edge(clk_sys_i) then
      if rst_n_i = '0' then
        -- Reset of the core
        int_regs_wb_m_i <= c_DUMMY_WB_MASTER_IN;
          int_ctrlreg0_o <= std_logic_vector(to_unsigned(0,32)); -- Hex value: 0x0
          int_ctrlreg1_o <= std_logic_vector(to_unsigned(0,32)); -- Hex value: 0x0
          int_ctrlreg2_o <= std_logic_vector(to_unsigned(0,32)); -- Hex value: 0x0
          int_ctrlreg3_o <= std_logic_vector(to_unsigned(0,32)); -- Hex value: 0x0
          int_ctrlreg4_o <= std_logic_vector(to_unsigned(0,32)); -- Hex value: 0x0
          int_ctrlreg5_o <= std_logic_vector(to_unsigned(0,32)); -- Hex value: 0x0
          int_ctrlreg6_o <= std_logic_vector(to_unsigned(0,32)); -- Hex value: 0x0

      else
        -- Normal operation
        int_regs_wb_m_i.rty <= '0';
        int_regs_wb_m_i.ack <= '0';
        int_regs_wb_m_i.err <= '0';

        if (int_regs_wb_m_o.cyc = '1') and (int_regs_wb_m_o.stb = '1') then
          int_regs_wb_m_i.err <= '1'; -- in case of missed address
          -- Access, now we handle consecutive registers
          case int_addr is
          when "0010" => -- 0x2
             int_regs_wb_m_i.dat <= std_logic_vector(int_ctrlreg0_o);
             if int_regs_wb_m_o.we = '1' then
               int_ctrlreg0_o <= std_logic_vector(int_regs_wb_m_o.dat);
             end if;
             int_regs_wb_m_i.ack <= '1';
             int_regs_wb_m_i.err <= '0';
          when "0011" => -- 0x3
             int_regs_wb_m_i.dat <= std_logic_vector(int_ctrlreg1_o);
             if int_regs_wb_m_o.we = '1' then
               int_ctrlreg1_o <= std_logic_vector(int_regs_wb_m_o.dat);
             end if;
             int_regs_wb_m_i.ack <= '1';
             int_regs_wb_m_i.err <= '0';
          when "0100" => -- 0x4
             int_regs_wb_m_i.dat <= std_logic_vector(int_ctrlreg2_o);
             if int_regs_wb_m_o.we = '1' then
               int_ctrlreg2_o <= std_logic_vector(int_regs_wb_m_o.dat);
             end if;
             int_regs_wb_m_i.ack <= '1';
             int_regs_wb_m_i.err <= '0';
          when "0101" => -- 0x5
             int_regs_wb_m_i.dat <= std_logic_vector(int_ctrlreg3_o);
             if int_regs_wb_m_o.we = '1' then
               int_ctrlreg3_o <= std_logic_vector(int_regs_wb_m_o.dat);
             end if;
             int_regs_wb_m_i.ack <= '1';
             int_regs_wb_m_i.err <= '0';
          when "0110" => -- 0x6
             int_regs_wb_m_i.dat <= std_logic_vector(int_ctrlreg4_o);
             if int_regs_wb_m_o.we = '1' then
               int_ctrlreg4_o <= std_logic_vector(int_regs_wb_m_o.dat);
             end if;
             int_regs_wb_m_i.ack <= '1';
             int_regs_wb_m_i.err <= '0';
          when "0111" => -- 0x7
             int_regs_wb_m_i.dat <= std_logic_vector(int_ctrlreg5_o);
             if int_regs_wb_m_o.we = '1' then
               int_ctrlreg5_o <= std_logic_vector(int_regs_wb_m_o.dat);
             end if;
             int_regs_wb_m_i.ack <= '1';
             int_regs_wb_m_i.err <= '0';
          when "1000" => -- 0x8
             int_regs_wb_m_i.dat <= std_logic_vector(int_ctrlreg6_o);
             if int_regs_wb_m_o.we = '1' then
               int_ctrlreg6_o <= std_logic_vector(int_regs_wb_m_o.dat);
             end if;
             int_regs_wb_m_i.ack <= '1';
             int_regs_wb_m_i.err <= '0';

          when "0000" =>
             int_regs_wb_m_i.dat <= x"53c0bf33";
             int_regs_wb_m_i.ack <= '1';
             int_regs_wb_m_i.err <= '0';
          when "0001" =>
             int_regs_wb_m_i.dat <= x"5cb25d31";
             int_regs_wb_m_i.ack <= '1';
             int_regs_wb_m_i.err <= '0';
          when others =>
             int_regs_wb_m_i.dat <= x"A5A5A5A5";
             int_regs_wb_m_i.ack <= '1';
             int_regs_wb_m_i.err <= '0';
          end case;
        end if;
      end if;
    end if;
  end process;
  ctrlreg0_o <= int_ctrlreg0_o;
  ctrlreg1_o <= int_ctrlreg1_o;
  ctrlreg2_o <= int_ctrlreg2_o;
  ctrlreg3_o <= int_ctrlreg3_o;
  ctrlreg4_o <= int_ctrlreg4_o;
  ctrlreg5_o <= int_ctrlreg5_o;
  ctrlreg6_o <= int_ctrlreg6_o;
  wb_m_i(0) <= int_regs_wb_m_i;
  int_regs_wb_m_o  <= wb_m_o(0);

end architecture;
