  --- This code is automatically generated by the addrgen_wb.py tool
  --- Please don't edit it manaully, unless you really have to do it.

  library ieee;
  use ieee.std_logic_1164.all;
  use ieee.numeric_std.all;
  library general_cores;
  use general_cores.wishbone_pkg.all;
  library work;
  use work.ec_ctrl_pkg.all;

  entity ec_ctrl is
    port (
      slave_i : in t_wishbone_slave_in;
      slave_o : out t_wishbone_slave_out;

      ctrl_o : out  t_ctrl_ec;
      ctrl_o_stb : out std_logic;
      tx_cmd_o : out  t_tx_cmd;
      tx_data_o : out  t_ec_tx_data;
      status_i : in  t_status_ec;
      status2_i : in  t_status2_ec;
      rx_data_i : in  t_ec_rx_data;
      rx_data_i_ack : out std_logic;

      rst_n_i : in std_logic;
      clk_sys_i : in std_logic
      );

  end ec_ctrl;

  architecture gener of ec_ctrl is
      signal int_ctrl_o : t_ctrl_ec;
    signal int_ctrl_o_stb : std_logic;
    signal int_tx_cmd_o : t_tx_cmd;
    signal int_tx_data_o : t_ec_tx_data;

    -- Internal WB declaration
    signal int_regs_wb_m_o : t_wishbone_master_out;
    signal int_regs_wb_m_i : t_wishbone_master_in;
    signal int_addr : std_logic_vector(3-1 downto 0);
    signal wb_up_o : t_wishbone_slave_out_array(0 to 0);
    signal wb_up_i : t_wishbone_slave_in_array(0 to 0);
    signal wb_m_o : t_wishbone_master_out_array(0 to 1-1);
    signal wb_m_i : t_wishbone_master_in_array(0 to 1-1);

    -- Constants
    constant c_address : t_wishbone_address_array(0 to 1-1) := (0=>"00000000000000000000000000000000");
    constant c_mask : t_wishbone_address_array(0 to 1-1) := (0=>"00000000000000000000000000000000");

  begin
    wb_up_i(0) <= slave_i;
    slave_o <= wb_up_o(0);
    int_addr <= int_regs_wb_m_o.adr(3-1 downto 0);

  -- Main crossbar
    xwb_crossbar_1: entity general_cores.xwb_crossbar
    generic map (
       g_num_masters => 1,
       g_num_slaves  => 1,
       g_registered  => false,
       g_address     => c_address,
       g_mask        => c_mask)
    port map (
       clk_sys_i => clk_sys_i,
       rst_n_i   => rst_n_i,
        slave_i   => wb_up_i,
        slave_o   => wb_up_o,
       master_i  => wb_m_i,
       master_o  => wb_m_o,
      sdb_sel_o => open);

  -- Process for register access
    process(clk_sys_i)
    begin
      if rising_edge(clk_sys_i) then
        if rst_n_i = '0' then
          -- Reset of the core
          int_regs_wb_m_i <= c_DUMMY_WB_MASTER_IN;
  
        else
          -- Normal operation
          int_regs_wb_m_i.rty <= '0';
          int_regs_wb_m_i.ack <= '0';
          int_regs_wb_m_i.err <= '0';
          int_ctrl_o_stb <= '0';
          rx_data_i_ack <= '0';

          if (int_regs_wb_m_o.cyc = '1') and (int_regs_wb_m_o.stb = '1')
              and (int_regs_wb_m_i.err = '0') and (int_regs_wb_m_i.rty = '0')
              and (int_regs_wb_m_i.ack = '0') then
            int_regs_wb_m_i.err <= '1'; -- in case of missed address
            -- Access, now we handle consecutive registers
            case int_addr is
            when "010" => -- 0x2
               int_regs_wb_m_i.dat <= (others => '0');
               int_regs_wb_m_i.dat(3 downto 0) <= to_slv(int_ctrl_o);
               if int_regs_wb_m_o.we = '1' then
                 int_ctrl_o <= to_ctrl_ec(int_regs_wb_m_o.dat(3 downto 0));
               if int_regs_wb_m_i.ack = '0' then
                  int_ctrl_o_stb <= '1';
               end if;
               end if;
               int_regs_wb_m_i.ack <= '1';
               int_regs_wb_m_i.err <= '0';
            when "011" => -- 0x3
               int_regs_wb_m_i.dat <= (others => '0');
               int_regs_wb_m_i.dat(31 downto 0) <= to_slv(int_tx_cmd_o);
               if int_regs_wb_m_o.we = '1' then
                 int_tx_cmd_o <= to_tx_cmd(int_regs_wb_m_o.dat(31 downto 0));
               end if;
               int_regs_wb_m_i.ack <= '1';
               int_regs_wb_m_i.err <= '0';
            when "100" => -- 0x4
               int_regs_wb_m_i.dat <= (others => '0');
               int_regs_wb_m_i.dat(31 downto 0) <= std_logic_vector(int_tx_data_o);
               if int_regs_wb_m_o.we = '1' then
                 int_tx_data_o <= std_logic_vector(int_regs_wb_m_o.dat(31 downto 0));
               end if;
               int_regs_wb_m_i.ack <= '1';
               int_regs_wb_m_i.err <= '0';
            when "101" => -- 0x5
               int_regs_wb_m_i.dat <= (others => '0');
               int_regs_wb_m_i.dat(16 downto 0) <= to_slv(status_i);
               int_regs_wb_m_i.ack <= '1';
               int_regs_wb_m_i.err <= '0';
            when "110" => -- 0x6
               int_regs_wb_m_i.dat <= (others => '0');
               int_regs_wb_m_i.dat(31 downto 0) <= to_slv(status2_i);
               int_regs_wb_m_i.ack <= '1';
               int_regs_wb_m_i.err <= '0';
            when "111" => -- 0x7
               int_regs_wb_m_i.dat <= (others => '0');
               int_regs_wb_m_i.dat(31 downto 0) <= std_logic_vector(rx_data_i);
               if int_regs_wb_m_i.ack = '0' then
                  rx_data_i_ack <= '1';
               end if;
               int_regs_wb_m_i.ack <= '1';
               int_regs_wb_m_i.err <= '0';

            when "000" =>
               int_regs_wb_m_i.dat <= x"53a737b4";
               int_regs_wb_m_i.ack <= '1';
               int_regs_wb_m_i.err <= '0';
            when "001" =>
               int_regs_wb_m_i.dat <= x"3e84e4db";
               int_regs_wb_m_i.ack <= '1';
               int_regs_wb_m_i.err <= '0';
            when others =>
               int_regs_wb_m_i.dat <= x"A5A5A5A5";
               int_regs_wb_m_i.ack <= '0';
               int_regs_wb_m_i.err <= '1';
            end case;
          end if;
        end if;
      end if;
    end process;
    ctrl_o <= int_ctrl_o;
    ctrl_o_stb <= int_ctrl_o_stb;
    tx_cmd_o <= int_tx_cmd_o;
    tx_data_o <= int_tx_data_o;
    wb_m_i(0) <= int_regs_wb_m_i;
    int_regs_wb_m_o  <= wb_m_o(0);

  end architecture;
