  --- This code is automatically generated by the addrgen_wb.py tool
  --- Please don't edit it manaully, unless you really have to do it.

  library ieee;
  use ieee.std_logic_1164.all;
  use ieee.numeric_std.all;
  library general_cores;
  use general_cores.wishbone_pkg.all;
  library work;
  use work.gbtsc_top_pkg.all;

  entity gbtsc_top is
    port (
      slave_i : in t_wishbone_slave_in;
      slave_o : out t_wishbone_slave_out;
      ic_wb_m_o : out t_wishbone_master_out;
      ic_wb_m_i : in t_wishbone_master_in;
      ec_wb_m_o : out t_wishbone_master_out;
      ec_wb_m_i : in t_wishbone_master_in;


      rst_n_i : in std_logic;
      clk_sys_i : in std_logic
      );

  end gbtsc_top;

  architecture gener of gbtsc_top is
  
    -- Internal WB declaration
    signal int_regs_wb_m_o : t_wishbone_master_out;
    signal int_regs_wb_m_i : t_wishbone_master_in;
    signal int_addr : std_logic_vector(1-1 downto 0);
    signal wb_up_o : t_wishbone_slave_out_array(0 to 0);
    signal wb_up_i : t_wishbone_slave_in_array(0 to 0);
    signal wb_m_o : t_wishbone_master_out_array(0 to 3-1);
    signal wb_m_i : t_wishbone_master_in_array(0 to 3-1);

    -- Constants
    constant c_address : t_wishbone_address_array(0 to 3-1) := (0=>"00000000000000000000000000011000",1=>"00000000000000000000000000010000",2=>"00000000000000000000000000000000");
    constant c_mask : t_wishbone_address_array(0 to 3-1) := (0=>"00000000000000000000000000011000",1=>"00000000000000000000000000011000",2=>"00000000000000000000000000011110");

  begin
    wb_up_i(0) <= slave_i;
    slave_o <= wb_up_o(0);
    int_addr <= int_regs_wb_m_o.adr(1-1 downto 0);

  -- Main crossbar
    xwb_crossbar_1: entity general_cores.xwb_crossbar
    generic map (
       g_num_masters => 1,
       g_num_slaves  => 3,
       g_registered  => false,
       g_address     => c_address,
       g_mask        => c_mask)
    port map (
       clk_sys_i => clk_sys_i,
       rst_n_i   => rst_n_i,
        slave_i   => wb_up_i,
        slave_o   => wb_up_o,
       master_i  => wb_m_i,
       master_o  => wb_m_o,
      sdb_sel_o => open);

  -- Process for register access
    process(clk_sys_i)
    begin
      if rising_edge(clk_sys_i) then
        if rst_n_i = '0' then
          -- Reset of the core
          int_regs_wb_m_i <= c_DUMMY_WB_MASTER_IN;
  
        else
          -- Normal operation
          int_regs_wb_m_i.rty <= '0';
          int_regs_wb_m_i.ack <= '0';
          int_regs_wb_m_i.err <= '0';

          if (int_regs_wb_m_o.cyc = '1') and (int_regs_wb_m_o.stb = '1')
              and (int_regs_wb_m_i.err = '0') and (int_regs_wb_m_i.rty = '0')
              and (int_regs_wb_m_i.ack = '0') then
            int_regs_wb_m_i.err <= '1'; -- in case of missed address
            -- Access, now we handle consecutive registers
            case int_addr is

            when "0" =>
               int_regs_wb_m_i.dat <= x"753000e3";
               int_regs_wb_m_i.ack <= '1';
               int_regs_wb_m_i.err <= '0';
            when "1" =>
               int_regs_wb_m_i.dat <= x"3e84e4db";
               int_regs_wb_m_i.ack <= '1';
               int_regs_wb_m_i.err <= '0';
            when others =>
               int_regs_wb_m_i.dat <= x"A5A5A5A5";
               int_regs_wb_m_i.ack <= '0';
               int_regs_wb_m_i.err <= '1';
            end case;
          end if;
        end if;
      end if;
    end process;
    wb_m_i(0) <= ic_wb_m_i;
    ic_wb_m_o  <= wb_m_o(0);
    wb_m_i(1) <= ec_wb_m_i;
    ec_wb_m_o  <= wb_m_o(1);
    wb_m_i(2) <= int_regs_wb_m_i;
    int_regs_wb_m_o  <= wb_m_o(2);

  end architecture;
