-- IEEE VHDL standard library:
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

library  agwb;

package gbt_fpga_common_pkg is  
  
  --================================= Array Declarations ================================-- 
  type t_diff_pair is record
    p  : std_logic;
    n  : std_logic;
  end record t_diff_pair;
  
  type t_diff_pair_arr  is array (natural range <>) of t_diff_pair;  

  --for CROB3
  type t_3diff_pair_arr  is array (natural range <>) of t_diff_pair(2 downto 0);

  
  type t_slv116_arr     is array (natural range <>) of std_logic_vector(115 downto 0);
  type t_slv112_arr     is array (natural range <>) of std_logic_vector(111 downto 0);
  type t_slv84_arr      is array (natural range <>) of std_logic_vector(83 downto 0);
  type t_slv80_arr      is array (natural range <>) of std_logic_vector(79 downto 0);
  type t_slv32_arr      is array (natural range <>) of std_logic_vector(31 downto 0);
    

  type t_crob3_serial_uplink is record
    master     : t_diff_pair;
    slave0     : t_diff_pair;
    slave1     : t_diff_pair;
  end record t_crob3_serial_uplink;

  type t_crob3_serial_downlink is record
    master     : t_diff_pair;
    slave0     : t_diff_pair;
    slave1     : t_diff_pair;
  end record t_crob3_serial_downlink;


  type t_crob3_para_uplink is record
    master     : std_logic_vector(111 downto 0);
    slave0     : std_logic_vector(111 downto 0);
    slave1     : std_logic_vector(111 downto 0);
  end record t_crob3_para_uplink;

  subtype t_crob3_para_downlink     is std_logic_vector(79 downto 0);
  
  type t_crob3_serial_uplink_arr    is array (natural range <>) of t_crob3_serial_uplink;
  type t_crob3_serial_downlink_arr  is array (natural range <>) of t_crob3_serial_downlink;
  type t_crob3_para_uplink_arr      is array (natural range <>) of t_crob3_para_uplink;
  type t_crob3_para_downlink_arr    is array (natural range <>) of t_crob3_para_downlink;

   --=====================================================================================--   
end gbt_fpga_common_pkg;

--=================================================================================================--
--#####################################   Package Body   ##########################################--
--=================================================================================================--

package body gbt_fpga_common_pkg is

   --=====================================================================================--   
end gbt_fpga_common_pkg;
--=================================================================================================--
--#################################################################################################--
--=================================================================================================--